﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.Threading.Tasks;
using Nito.AsyncEx;
using System.Linq;
using System.Threading;
using System.Collections.Concurrent;
using System.Diagnostics.CodeAnalysis;

namespace Tests
{
    [ExcludeFromCodeCoverage]
    [TestClass]
    public class ProducerProgressUnitTests_NET40
    {
        [TestMethod]
        public void ProgressReports_AreSentToCollection()
        {
            AsyncContext.Run(async () =>
            {
                var queue = new ConcurrentQueue<int>();
                IProgress<int> progress = new ProducerProgress<int>(queue);
                await TaskEx.Run(() =>
                {
                    progress.Report(13);
                    progress.Report(17);
                });
                Assert.IsTrue(queue.SequenceEqual(new[] { 13, 17 }));
            });
        }
    }
}
