﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.Runtime.CompilerServices;
using Nito.AsyncEx;
using System.Diagnostics.CodeAnalysis;

namespace Tests
{
    [ExcludeFromCodeCoverage]
    [TestClass]
    public class ExceptionHelpersUnitTests_NET45_NE
    {
        [MethodImpl(MethodImplOptions.NoInlining)]
        private static void ThrowNotImplementedException()
        {
            throw new NotImplementedException();
        }

        [TestMethod]
        public void PrepareForRethrow_PreservesStackTrace()
        {
            string originalStackTrace = null;
            try
            {
                Exception preservedException = null;
                try
                {
                    ThrowNotImplementedException();
                }
                catch (NotImplementedException ex)
                {
                    originalStackTrace = ex.StackTrace;
                    preservedException = ex;
                }

                throw ExceptionHelpers.PrepareForRethrow(preservedException);
            }
            catch (NotImplementedException ex)
            {
                Assert.IsTrue(ex.StackTrace.StartsWith(originalStackTrace));
                return;
            }
        }
    }
}
