﻿using System;
using System.Collections.Generic;
using System.Diagnostics.CodeAnalysis;
using System.Dynamic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

[ExcludeFromCodeCoverage]
internal sealed class DebugEtw
{
    public static DebugEtw Start(Func<Event, bool> filter = null)
    {
        return new DebugEtw();
    }

    public EventCollection Stop() { return Stop(null, null); }
    public EventCollection Stop(Func<Event, bool> filter) { return Stop(filter, null); }
    public EventCollection Stop(Func<Event, Event, bool> related) { return Stop(null, related); }
    public EventCollection Stop(Func<Event, bool> filter, Func<Event, Event, bool> related)
    {
        return new EventCollection();
    }

    public EventCollection Snapshot() { return Snapshot(null, null); }
    public EventCollection Snapshot(Func<Event, bool> filter) { return Snapshot(filter, null); }
    public EventCollection Snapshot(Func<Event, Event, bool> related) { return Snapshot(null, related); }
    public EventCollection Snapshot(Func<Event, bool> filter, Func<Event, Event, bool> related)
    {
        return new EventCollection();
    }

    public sealed class Event
    {
        public Event() { Bag = new ExpandoObject(); }
        public string SourceName { get { return null; } }
        public int Id { get { return 0; } }
        public byte Version { get { return 0; } }
        public dynamic Bag { get; private set; }
        public IEnumerable<string> DataNames { get { return Enumerable.Empty<string>(); } }
        public IEnumerable<object> DataValues { get { return Enumerable.Empty<object>(); } }
        public dynamic Data { get; private set; }
        public bool DataMatches(object _) { return false; }
    }

    public sealed class EventCollection
    {
        public EventCollection() { Bag = new ExpandoObject(); }
        public dynamic Bag { get; private set; }
        public EventCollection Expect(ExpectedEtwEvent _, object __) { return this; }
        public void ExpectDone() { }
        public Event this[int index] { get { return new Event(); } }
        public int Count { get { return 0; } }
    }
}

[ExcludeFromCodeCoverage]
internal static class EtwRelations
{
    public static bool HaveRelatedTasks(DebugEtw.Event a, DebugEtw.Event b) { return false; }
}

[ExcludeFromCodeCoverage]
internal sealed class ExpectedEtwEvent
{
    public ExpectedEtwEvent(string sourceName, int id, int version)
    {
    }
}
