﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.Threading.Tasks;
using Nito.AsyncEx;
using System.Linq;
using System.Threading;
using System.Collections.Concurrent;
using System.Diagnostics.CodeAnalysis;
using Nito.AsyncEx.Internal;

namespace Tests
{
    [ExcludeFromCodeCoverage]
    [TestClass]
    public class ProducerProgressUnitTests
    {
        [TestMethod]
        public async Task ProgressReports_AreSentToCollection()
        {
            var queue = new ConcurrentQueue<int>();
            IProgress<int> progress = new ProducerProgress<int>(queue);
            await Task.Run(() =>
            {
                progress.Report(13);
                progress.Report(17);
            });
            Assert.IsTrue(queue.SequenceEqual(new[] { 13, 17 }));
        }
    }
}
